SystemOrganization addCategory: #'Glamour-FastTable'!
SystemOrganization addCategory: 'Glamour-FastTable-Announcement'!
SystemOrganization addCategory: 'Glamour-FastTable-Model'!
SystemOrganization addCategory: 'Glamour-FastTable-Morphic-Renderer'!
SystemOrganization addCategory: 'Glamour-FastTable-Presentations'!

Trait named: #TGLMFastTable
	uses: {}
	category: 'Glamour-FastTable-Model'!

!TGLMFastTable commentStamp: 'CyrilFerlicot 11/10/2015 11:45' prior: 0!
I am a Trait that manage some Glamour Model related functionalities. 

Description 
--------------------

I contains some functionnalities used by all the Glamour related data sources like the annoucements. Since a dataSource can be a list, or a outline list, or a tree … They cannot inherit from the same class. I am here to avoid a duplication of code.!

!TGLMFastTable methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 15:21'!
allMenuActions
	^ self glamourPresentation allSelectionActions select: #hasTitle! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
announcer
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
basicElements
	^ self glamourPresentation displayValue! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
calculateElements
	^ self basicElements select: [ :each | self elementShouldBeDisplayed: each ].
! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
collectionToDragPassenger: aCollection
	^ aCollection size = 1
		ifTrue: [ aCollection anyOne ] 
		ifFalse: [ aCollection ]! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
elementOrZeroAt: rowIndex
	^ rowIndex = 0 
		ifTrue: [ 0 ] 
		ifFalse: [ self elementAt: rowIndex ] 
	! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
elementShouldBeDisplayed: anObject
	| elementTags |
	self tagsToFilterBy ifEmpty: [ ^ true ].
	elementTags := self glamourPresentation tagsFor: anObject to: #filter.
	^ self tagsToFilterBy allSatisfy: [ :each | elementTags includes: each ]! !

!TGLMFastTable methodsFor: 'menu' stamp: 'CyrilFerlicot 11/4/2015 17:22'!
executeMenuAction: anAction
	self announcer announce: (GLMMenuItemSelected action: anAction)! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'CyrilFerlicot 1/5/2016 12:15'!
explicitSelection: anObject 
	self table selectRowIndex: (self elements indexOf: anObject)! !

!TGLMFastTable methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation: anObject
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'menu' stamp: 'PabloTesone 10/11/2016 11:00'!
menuColumn: column row: rowIndex
	| menu subMenus targetMenuMorph subMenu |
	
	menu := UIManager default newMenuIn: self table for: self.
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					menu add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ menu ].
		(targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action)
			icon:  action icon;
			enabled: (action isEnabledOn: self glamourPresentation);
			keyText: (action hasShortcut 
				ifTrue: [ action shortcutAsString ]
				ifFalse: [ nil ]) ].
	^ menu! !

!TGLMFastTable methodsFor: 'instance creation' stamp: 'CyrilFerlicot 11/17/2015 12:13'!
newDataSourceMatching: aRegex
	^ (super newDataSourceMatching: aRegex)
		glamourPresentation: self glamourPresentation;
		yourself! !

!TGLMFastTable methodsFor: 'private' stamp: 'usmanbhatti 11/17/2015 10:28'!
readyToBeDisplayed
	self glamourPresentation announcer announce: (GLMDataSourceUpdated newDataSource: self).! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 16:26'!
selection: ann
	| selection |
	selection := ann newSelectedRowIndexes select: [ :each | each ~= 0 ] thenCollect: [ :each | self elementAt: each ].
	selection
		ifNotEmpty: [ 
			self announcer
				announce:
					(GLMTreeMorphSelectionChanged new
						selectionValue:
								(selection size = 1
										ifTrue: [ selection first ]
										ifFalse: [ selection ]);
						selectionPathValue: selection;
						yourself) ]! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 15:28'!
strongSelection: ann
	self announcer announce: (GLMTreeMorphStrongSelectionChanged new 
		strongSelectionValue: (self elementAt: ann selectedRowIndex);
		yourself)! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
when: anAnnouncementClass do: aBlock
	self announcer when: anAnnouncementClass do: aBlock! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
when: anAnnouncementClass send: selector to: target
	self announcer 
		when: anAnnouncementClass 
		send: selector 
		to: target! !

Trait named: #TGLMFastTableFunctionsPresentation
	uses: {}
	category: 'Glamour-FastTable-Presentations'!

!TGLMFastTableFunctionsPresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:31' prior: 0!
I am a Trait that manage the differents functionnalities for a FastTable related presentation.

Description
--------------------

My users have to define a #parameters method that need to be a getter for a Dictionary. Then I will store the informations I manage into this dictionary.

I work with all the presentations that use a FastTable as GLMFastLastPresentation, GLMFastTablePresentation or GLMFastTreePresentation.

Public API and Key Messages
--------------------

- #enableFilter 		add a filter to the GLMFastTable. (not compatible with the search)

- #enableSearch 		add a search to the GLMFastTable (A filter will remove the elements that doesn't match when a search will just highlight the matching results).
		
- #enableFilterWithAction: aBlock / #enableFilterWithAction:  aBlock named: aString 		add a filter and an action button. The action is define by a block that can take 3 parameters (the dataSource with the currents elements, the current filter pattern and the selected row of the table)
		
#searchOn: and #filterOn: are not implemented yet.

Example
--------------------

	aGLMFastTablePresentation enableFilterWithAction: [ :dataSource :pattern :item | item browse ] named: 'Browse'. 

Internal Representation and Key Implementation Points.
--------------------

To remember the options I keep some values inside a Dictionary. This dictionary is manage by a presentation and I get it via the #parameters method.!

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:23'!
actionBlock
	^ self parameters at: 'actionBlock'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:42'!
actionName
	^ self parameters at: 'actionName' ifAbsent: 'Validate'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:16'!
enableFilter
	self parameters at: 'isFilterable' put: true
	! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:41'!
enableFilterWithAction: aBlock
	self enableFilter.
	self parameters at: 'actionBlock' put: aBlock! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:41'!
enableFilterWithAction: aBlock named: aString
	self enableFilter.
	self parameters
		at: 'actionBlock' put: aBlock;
		at: 'actionName' put: aString! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:16'!
enableSearch
	self parameters at: 'isSearchable' put: true! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 15:26'!
filterOn: aBlock
	self error: 'This presentation does not allow filtering with a block for now. In the futur we should have a new filter with FastTable to do that. If you want to give it a try look FTFunction and his subclasses.'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:17'!
isFilterable
	^ self parameters at: 'isFilterable' ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:17'!
isSearchable
	^ self parameters at: 'isSearchable' ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:18'!
needActionButton
	^ self parameters at: 'actionBlock' ifPresent: [ true ] ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:20'!
parameters
	self explicitRequirement! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 15:27'!
searchOn: aBlock
	self error: 'This presentation does not allow searching with a block for now. In the futur we should have a new filter with FastTable to do that. If you want to give it a try look FTFunction and his subclasses.'! !

Trait named: #TGLMFastTableTag
	uses: {}
	category: 'Glamour-FastTable-Model'!

!TGLMFastTableTag commentStamp: 'CyrilFerlicot 11/10/2015 11:47' prior: 0!
I am a Trait class use to manage some basic functionnalities needed to manage tags in a Gl̂amour data source.

My user need to define the #tagToFilterBy which should return a collection of tag, then I manage some basics needs.!

!TGLMFastTableTag methodsFor: 'factory' stamp: 'CyrilFerlicot 11/9/2015 17:06'!
buttonForTag: each filter: filter
	^ (GLMMorphic togglingButtonLabelled: each pressed: (self shouldFilterByTag: filter) style: self glamourPresentation tagsStyle)
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: filter);
		yourself! !

!TGLMFastTableTag methodsFor: 'private' stamp: 'CyrilFerlicot 11/9/2015 17:12'!
resetChildrenContent
	self explicitRequirement! !

!TGLMFastTableTag methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 17:05'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!TGLMFastTableTag methodsFor: 'factory' stamp: 'CyrilFerlicot 11/9/2015 17:08'!
tagMorphsFrom: aTagProvider for: element
	| tagMorphs tags tagsFilter |
	
	tagMorphs := OrderedCollection new.
	tags:= self glamourPresentation tagsFor: element fromProvider: aTagProvider to: #show.
	tagsFilter := self glamourPresentation tagsFor: element fromProvider: aTagProvider to: #filter.
	tags withIndexDo:[ :each :index | 
		tagMorphs addLast: (self 
			buttonForTag: each 
			filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
	^ tagMorphs! !

!TGLMFastTableTag methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 17:04'!
tagsToFilterBy
	self explicitRequirement! !

!TGLMFastTableTag methodsFor: 'callbacks' stamp: 'CyrilFerlicot 12/30/2015 16:03'!
toggleFilteringByTag: aTag
	(self shouldFilterByTag: aTag)
		ifTrue: [ self tagsToFilterBy remove: aTag ]
		ifFalse: [ self tagsToFilterBy add: aTag ].
	self resetChildrenContent.
	self tableRefresh! !

GLMMorphicTest subclass: #GLMMorphicFTTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFTTest methodsFor: 'tests' stamp: 'TudorGirba 1/30/2016 08:15'!
testNoDuplicateRegistrationOfAnnouncementsOnDataSource
	| table amountOfMenuItemSelectedSubscriptions |
	window := GLMCompositePresentation new 
			with: [ :c | 
				c fastList selectionAct: [ 42 inspect ] entitled: 'Answer' ];
			openOn: (1 to: 42).
	table := self find: FTTableMorph in: window.
	amountOfMenuItemSelectedSubscriptions := table dataSource announcer subscriptions glmSubscriptions count: [ :each | each announcementClass = GLMMenuItemSelected ].
	self assert: amountOfMenuItemSelectedSubscriptions equals: 1! !

GLMListPresentation subclass: #GLMFastListPresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastListPresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:52' prior: 0!
I'm a fast list presentation who introduces FTTableMorph into Glamour. 

Description 
-------------------

I just know how to render myself and I manage some options that the user can use for the FastTable.

The user can use almost all the functionalities of my superclass and some more. I work with a GLMMorphicFastListRenderer to render the list.  

Public API and Key Messages
-------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment) and you can finally use:

- #withSeparators 		I the input I receive is a collection of collection I will dispaly a list with separators between the collections.

Example
-------------------

GLMWrapper new 
	show: [ :a | 
		a fastList
			display: [ :x | 1 to: x ]];
	openOn: 1000.
	
or

GLMWrapper new 
	show: [ :a | 
		a fastList
				title: 'Example with an Outline List';
				display: [ :x | (x allSubclasses sort: [ :a :b | a asString < b asString  ]) collect: #allSubclasses  ];
				enableSearch;
				withSeparators
			];
	openOn: ProtoObject.

 
Internal Representation and Key Implementation Points.
-------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some parameters of the presentation.
!

GLMFastListPresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastListPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 16:31'!
allowSeparators
	^ self parameters at: 'withSeparators' ifAbsent: [ false ]! !

!GLMFastListPresentation methodsFor: 'initialize-release' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastListPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:07'!
parameters
	^ parameters! !

!GLMFastListPresentation methodsFor: 'rendering' stamp: 'EstebanLorenzano 6/18/2015 12:01'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastListPresentation: self! !

!GLMFastListPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:31'!
withSeparators
	self parameters at: 'withSeparators' put: true! !

FTColumn subclass: #GLMFastTableColumn
	instanceVariableNames: 'glamourColumn target selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTableColumn commentStamp: '<historical>' prior: 0!
I'm a glamour column for fast tables.!

!GLMFastTableColumn methodsFor: 'execute' stamp: 'EstebanLorenzano 6/17/2015 13:13'!
execute 
	target ifNil: [ ^ self ].
	selector ifNil: [ ^ self ].
	
	target perform: selector withArguments: arguments! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/13/2015 14:51'!
glamourColumn
	^ glamourColumn! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/13/2015 14:51'!
glamourColumn: anObject
	glamourColumn := anObject! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/16/2015 21:30'!
target: aTarget actionSelector: aSelector arguments: aCollection 
	target := aTarget. 
	selector := aSelector.
	arguments := aCollection! !

FTOutlineDataSource subclass: #GLMFastListOutlineDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'announcer glamourPresentation tagsToFilterBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastListOutlineDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast outline list presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastListPresentation and a GLMMorphicFastListRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastListOutlineDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastListOutlineDataSource methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:42'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:54'!
basicItems
	^ self glamourPresentation displayValue! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 16:49'!
calculateItems
	Halt once.
	^ self basicItems collect: [:coll | coll select: [ :each | self elementShouldBeDisplayed: each ] ]! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:39'!
cellColumn: column row: rowIndex 
	| element cell |
	
	element := self elementAt: rowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForElement: element);
		yourself.

	(self needSeparatorBefore: rowIndex)
		ifTrue: [ cell withTopSeparator ].

	^ cell! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:50'!
glamourPresentation: aGlamourPresentation
	glamourPresentation := aGlamourPresentation! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:52'!
items 
	^ items ifNil: [ items := self calculateItems ]! !

!GLMFastListOutlineDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/9/2015 17:13'!
resetChildrenContent
	items := self calculateItems.! !

!GLMFastListOutlineDataSource methodsFor: 'factory' stamp: 'CyrilFerlicot 11/16/2015 10:42'!
rowMorphForElement: element
	| rowElements |
	rowElements := OrderedCollection new.
	(self glamourPresentation icon cull: element) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self glamourPresentation formatedDisplayValueOf: element) asMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: element).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 16:05'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:00'!
renderFastListPresentation: aPresentation 
	^ GLMMorphicFastListRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/12/2015 17:33'!
renderFastTablePresentation: aPresentation 
	^ GLMMorphicFastTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/3/2015 14:38'!
renderFastTreePresentation: aPresentation 
	^ GLMMorphicFastTreeRenderer render: aPresentation from: self! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 11:58'!
fastList
	^ self custom: GLMFastListPresentation new! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/12/2015 18:05'!
fastTable
	^ self custom: GLMFastTablePresentation new! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/3/2015 14:35'!
fastTree
	^ self custom: GLMFastTreePresentation new! !

FTSimpleDataSource subclass: #GLMFastListDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'glamourPresentation announcer tagsToFilterBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastListDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast list presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastListPresentation and a GLMMorphicFastListRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastListDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
actionColumn: column
	"If columns has actions associated, execute them"
	column execute.
	self tableRefresh! !

!GLMFastListDataSource methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:37'!
cellColumn: column row: rowIndex
	| element cell |
	element := self elementAt: rowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForElement: element);
		yourself.
	^ cell! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
dragTransferType
	^ #Glamour! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
dropElements: aCollection index: rowIndex
	self glamourPresentation 
		accept: (self collectionToDragPassenger: aCollection)
		droppedOnItem: (self elementOrZeroAt: rowIndex)! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
elements
	^ elements ifNil: [ elements := self calculateElements ]! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
headerColumn: column
	column id ifNil: [ ^ nil ].
	^ SimpleButtonMorph new
		layoutPolicy: RowLayout new; 
		listDirection: #leftToRight; 
		wrapCentering: #center;
		cellInset: 5@0;
		layoutInset: 5@0;
		label: column id;
		target: self;
		actionSelector: #actionColumn:;
		arguments: {column};
		yourself! !

!GLMFastListDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/9/2015 17:11'!
resetChildrenContent
	elements := self calculateElements! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
resetElements
	elements := nil! !

!GLMFastListDataSource methodsFor: 'factory' stamp: 'AndreiChis 1/9/2016 20:23'!
rowMorphForElement: element
	| rowElements |
	rowElements := OrderedCollection new.
	(self glamourPresentation icon cull: element) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self glamourPresentation formatedDisplayValueOf: element) asMorph asReadOnlyMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: element).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastListDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/23/2015 11:47'!
selectTable: aTable element: anObject 
	aTable selectRowIndex: (self elements indexOf: anObject)! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMFastListDataSource methodsFor: 'factory' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
viewRowMorphForColumn: glamourColumn element: element
	^ (self glamourPresentation column: glamourColumn valueFor: element) asMorph asReadOnlyMorph! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 17:10'!
wantsDropElements: aCollection type: type index: rowIndex
	^ (aCollection isEmptyOrNil or: [ type ~= self dragTransferType ])
		ifFalse: [ self glamourPresentation allow: (self collectionToDragPassenger: aCollection) droppedOnItem: (self elementOrZeroAt: rowIndex) ]
		ifTrue: [ false ]! !

GLMFastListDataSource subclass: #GLMFastTableDataSource
	instanceVariableNames: 'columnToSortBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTableDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:54' prior: 0!
I'm a model datasource to handle glamour fast table presentations.

Description 
--------------------

I am a GLMFastListDataSource that can also manage multi columns.

I work with a GLMFastTablePresentation and a GLMMorphicFastTableRenderer. 
!

!GLMFastTableDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 14:40'!
cellColumn: column row: rowIndex 
	| element cell |
	
	element := self elementAt: rowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self 
			rowMorphForColumn: column glamourColumn 
			element: element);
		yourself.

	(self table columns first == column) ifTrue: [
		| icon |
		icon := self glamourPresentation icon cull: element.
		icon ifNotNil: [ cell addMorph: icon asMorph ] ].

	^ cell! !

!GLMFastTableDataSource methodsFor: 'factory' stamp: 'EstebanLorenzano 6/13/2015 16:25'!
editRowMorphForColumn: glamourColumn element: element
	| brick |
	
	(brick := GLMEditableLabelBrick new)
		cancelOnEscape;
		cancelOnFocusLost;
		text: (self valueFor: glamourColumn);
		hSpaceFill;
		with: [ :b | b editBrick rubricBackgroundColor: b themer rubricBackgroundColor ];
		"when: #onEditMode do: [ self containerTree forceStopStepping ];
		when: #onReadMode do: [ self containerTree resetStopStepping ];"
		"when: #onSingleClicked do: [ :event :b | b isReadMode ifTrue: [ self selectItem ] ];"
		"when: #onAccepted do: [ self modified: glamourColumn with: brick text ];"
		yourself.
			
	^ brick asMorph
		hSpaceFill;
		vShrinkWrap! !

!GLMFastTableDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 10/6/2015 16:58'!
elementsSorted
	elements ifNil: [ ^ nil ].
	^ columnToSortBy 
		ifNotNil: [ elements sorted: self sortBlock ]
		ifNil: [ self calculateElements ]! !

!GLMFastTableDataSource methodsFor: 'factory' stamp: 'CyrilFerlicot 11/9/2015 17:08'!
rowMorphForColumn: glamourColumn element: element
	| rowElements contentMorph tagMorphs |
		
	contentMorph := glamourColumn modifiedBlock
		ifNotNil: [ self editRowMorphForColumn: glamourColumn element: element ]
		ifNil: [ self viewRowMorphForColumn: glamourColumn element: element ].
	
	tagMorphs := self tagMorphsFrom: glamourColumn for: element.
	tagMorphs ifEmpty: [ ^ contentMorph ].
	
	rowElements := OrderedCollection new
		add: contentMorph;
		addAll: tagMorphs;
		yourself.
	
	^ (UITheme current newRowIn: World for: rowElements)	! !

!GLMFastTableDataSource methodsFor: 'private' stamp: 'EstebanLorenzano 6/16/2015 21:35'!
sortBlock
	^ columnToSortBy sortBlock ifNil: [ 
		columnToSortBy defaultSortBlockForPresentation: self glamourPresentation ]! !

!GLMFastTableDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 10/6/2015 16:59'!
sortByColumn: aGlamourColumn
	columnToSortBy := (columnToSortBy == aGlamourColumn 
		ifTrue: [ nil ]
		ifFalse: [ aGlamourColumn ]).
	elements := self elementsSorted.
	self glamourPresentation changed.! !

GLMTablePresentation subclass: #GLMFastTablePresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastTablePresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:58' prior: 0!
I'm a fast table presentation who introduces FTTableMorph into Glamour. 

Description
--------------------

I know how to render myself and I store some options for the Table.  I keep some options specific to the FastTable inside a Dictionary. 

I work with GLMMorphicFastTableRenderer to render the FastTable. I use TGLMFastTableFunctionsPresentation in order to manage some options.

Public API and Key Messages
--------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment).

For now I do not add any other api methods.

Example
--------------------

GLMWrapper new 
	show: [ :a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ]  ];
	openOn: 1000.

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some options related to the FastTable.
!

GLMFastTablePresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastTablePresentation class methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2016 11:15'!
defaultIntercellSpacing
	^ 3@1! !

!GLMFastTablePresentation methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastTablePresentation methodsFor: 'public api' stamp: 'EstebanLorenzano 11/29/2016 11:15'!
intercellSpacing
	^ self parameters 
		at: 'intercellSpacing' 
		ifAbsent: [ self class defaultIntercellSpacing ]! !

!GLMFastTablePresentation methodsFor: 'public api' stamp: 'AndreiChis 1/18/2016 19:14'!
intercellSpacing: aNumber
	self parameters at: 'intercellSpacing' put: aNumber! !

!GLMFastTablePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
parameters
	^ parameters! !

!GLMFastTablePresentation methodsFor: 'rendering' stamp: 'EstebanLorenzano 6/12/2015 17:22'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastTablePresentation: self! !

FTTreeDataSource subclass: #GLMFastTreeDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'glamourPresentation announcer tagsToFilterBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTreeDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast tree presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastTreePresentation and a GLMMorphicFastTreeRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastTreeDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 15:12'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/3/2015 15:06'!
basicRoots
	^ self glamourPresentation displayValue! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:27'!
cellColumn: aColumnIndex row: aRowIndex
	| item cell |
	item := self elementAt: aRowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForItem: item);
		yourself.
	^ cell! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 12/30/2015 15:54'!
createRootItem
	| fullRoot |
	fullRoot := FTRootItem data: self basicRoots from: self.
	^ self tagsToFilterBy
		ifEmpty: [ fullRoot ]
		ifNotEmpty:
			[ | children |
			children := OrderedCollection new.
			fullRoot children
				do: [ :item | (self matchingTag: item) ifNotNil: [ :itemNew | children add: itemNew ] ]
				displayingProgress: [ :each | 'Looking inside ' , each name ].
			FTRootItem new
				dataSource: self;
				children: children asArray;
				yourself ]! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 1/5/2016 12:31'!
explicitSelection: anObject
	self table selectRowIndexes: (self searchText: anObject asString)! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 14:59'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 10:31'!
glamourPresentation: aGLMFastTreePresentation
	glamourPresentation := aGLMFastTreePresentation! !

!GLMFastTreeDataSource methodsFor: 'tag' stamp: 'CyrilFerlicot 12/30/2015 16:01'!
matchingTag: anItem
	| elementTags |
	elementTags := self glamourPresentation tagsFor: anItem data to: #filter.
	((anItem children collect: [ :it | self matchingTag: it ]) reject: #isNil)
		ifNotEmpty: [ :coll | 
			^ (self newStaticItemFrom: anItem)
				children: coll asArray;
				yourself ].
	^ (self tagsToFilterBy allSatisfy: [ :each | elementTags includes: each ])
		ifFalse: [ nil ]
		ifTrue: [ self newStaticItemFrom: anItem ]! !

!GLMFastTreeDataSource methodsFor: 'instance creation' stamp: 'CyrilFerlicot 11/9/2015 16:00'!
newStaticItemFrom: anItem
	^ FTStaticBasicItem new
		data: anItem data;
		depth: anItem depth;
		children: #();
		dataSource: self;
		yourself! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/9/2015 17:16'!
resetChildrenContent
	self rootItem: self createRootItem! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:59'!
resetElements
	self updateData! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 15:04'!
rootItem
	^ rootItem ifNil: [ rootItem := self createRootItem ]! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/16/2015 10:46'!
rowMorphForItem: anItem
	| rowElements |
	rowElements := OrderedCollection new.
	anItem depth timesRepeat: [ rowElements add: self class emptyMorph ].
	rowElements add: (self buttonFor: anItem).
	(self glamourPresentation icon cull: anItem data) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self glamourPresentation formatedDisplayValueOf: anItem data) asMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: anItem data).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 16:26'!
selection: ann
	| selection |
	selection := ann newSelectedRowIndexes
		select: [ :each | each ~= 0 ]
		thenCollect: [ :each | (self elementAt: each) data ].
	selection
		ifNotEmpty: [ 
			self announcer
				announce:
					(GLMTreeMorphSelectionChanged new
						selectionValue:
								(selection size = 1
										ifTrue: [ selection first ]
										ifFalse: [ selection ]);
						selectionPathValue: selection;
						yourself) ]! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 15:30'!
strongSelection: ann
	self announcer
		announce:
			(GLMTreeMorphStrongSelectionChanged new
				strongSelectionValue: (self elementAt: ann selectedRowIndex) data;
				yourself)! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 15:18'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

GLMTreePresentation subclass: #GLMFastTreePresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastTreePresentation commentStamp: 'CyrilFerlicot 11/10/2015 14:06' prior: 0!
I'm a fast table presentation who introduces FTTableMorph into Glamour  as a Tree. 

Description
--------------------

I know how to render myself and I store some options for the Tree.  I keep some options specific to the FastTable inside a Dictionary. 

I work with GLMMorphicFastTreeRenderer to render the FastTable. I use TGLMFastTableFunctionsPresentation in order to manage some options.

Public API and Key Messages
--------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment) and you can also use:

- #maxDepth: anInteger 		to define a max depth for the tree.   
		
- #expandedUntil: aDepth 		this is use to expand the tree at the opening until a certain depth.
		 
- #strategy: aSymbole 		this is use to define a Strategy for the search or the filter inside a Tree. I can take in parameter #default, #rootsOnly, #allItems.
                #default is selected by default, it will search/filter the tree for all visible rows.       
               #rootsOnly will search/filter only the first level of the tree
               #allItems will search/filter all the Tree and open the needed items. Do not use this if the tree is not finish.

Example
--------------------

	GLMWrapper new
		show:
				[ :a | 
			a fastTree
				children: [ :x | x subclasses ];
				enableFilterWithAction: [ :dataSource :pattern :item | item browse ];
				strategy: #rootsOnly;
				maxDepth: 3;
				rootsExpanded ];
		openOn: (Object subclasses) asArray
 
Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some parameters of the presentation.
!

GLMFastTreePresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/10/2015 14:06'!
expandedUntil: anInteger
	self shouldExpandToLevel: anInteger! !

!GLMFastTreePresentation methodsFor: 'initialize-release' stamp: 'CyrilFerlicot 11/4/2015 11:02'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:25'!
maxDepth
	^ self parameters at: 'maxDepth' ifAbsent: [ nil ]! !

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:26'!
maxDepth: anInteger
	self parameters at: 'maxDepth' put: anInteger! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:03'!
parameters
	^ parameters! !

!GLMFastTreePresentation methodsFor: 'rendering' stamp: 'CyrilFerlicot 11/3/2015 14:37'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastTreePresentation: self! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:23'!
strategy
	^ self parameters at: 'strategy' ifAbsent: [ #default ]! !

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:23'!
strategy: aSymbole
	self parameters at: 'strategy' put: aSymbole! !

Announcement subclass: #GLMDataSourceUpdated
	instanceVariableNames: 'newDataSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Announcement'!

!GLMDataSourceUpdated commentStamp: 'CyrilFerlicot 11/16/2015 15:51' prior: 0!
I am an annoucement use by Glamour to signal that the dataSource of a Renderer changed.

Description 
--------------------

I keep a pointer to the new dataSource. 
I can be use when the user filter a FastTable for example.
I am use by a Fast related renderer in GLMMorphicFTRenderer.

Public API and Key Messages
------------------

- newDataSource: aDataSource 		is my constructor.
		
Internal Representation and Key Implementation Points.
------------------ 

    Instance Variables
	newDataSource:		The new DataSource.
!

!GLMDataSourceUpdated class methodsFor: 'instance creation' stamp: 'CyrilFerlicot 11/16/2015 15:47'!
newDataSource: aDataSource
	^ self new
		newDataSource: aDataSource;
		yourself! !

!GLMDataSourceUpdated methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 14:37'!
newDataSource
	^ newDataSource! !

!GLMDataSourceUpdated methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 14:37'!
newDataSource: anObject
	newDataSource := anObject! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 16:03'!
fastListDragAndDrop
	<glmBrowser: 'Fast List drag&drop' input: '(1 to: 5) asOrderedCollection'>
	"self new listDragAndDrop openOn: (1 to: 5) asOrderedCollection"
	| browser |
	browser := GLMTabulator new.
	browser column: #source; column: #target.
	browser transmit to: #source; andShow: [:a | 
		a fastList 
			title: 'Source';
			display: (1 to: 10);
			allowItemDrag: [:item :list | true ];
			transformDraggedItem: [:item :list | item + 100 ]
			].
	browser transmit to: #target; andShow: [:a |  
		a fastList
			title: 'Target'; 
			display: [:collection | collection ];
			allowDropOnItem: [:draggedObject :targetItem :list | draggedObject isNumber ];
			dropOnItem: [:draggedObject :targetItem :list | 
				list entity addLast: (targetItem + draggedObject).
				list update.
				true ]
			].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 16:06'!
fastListDropDown
	"self new fastListDropDown openOn: 5"
	<glmBrowser: 'Fast List Drop-down' input: '5'>

	|browser |

	browser := GLMTabulator new.
	browser row: #one size: 30; row: #two.
	browser transmit to: #one; andShow: [:a |
		a dropDownList
			display: [:x | 1 to: x ];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser transmit from: #one; to: #two; andShow: [:a |
		a fastList
			display: [:x | 1 to: x * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/16/2015 11:44'!
fastListFunctions
	"self new fastListFunctions openOn: ((Smalltalk allClassesAndTraits sort: [ :a :b | a asString < b asString ]) asArray)"

	"This can be done for a fastlist, a fastlist with separators, a fasttable and even a fastftree."

	<glmBrowser: 'Fast List with function' input: '(Smalltalk allClassesAndTraits sort: [ :a :b | a asString < b asString ]) asArray '>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow:
				[ :a | 
			a fastList
				title: 'Search';
				display: [ :input | input ];
				enableSearch.
			a fastList
				title: 'Filter';
				display: [ :input | input ];
				enableFilter.
			a fastList
				title: 'Filter and action';
				display: [ :input | input ];
				enableFilterWithAction: [ :dataSource :pattern :selectedRow | selectedRow browse ].
			a fastList
				title: 'Filter and named action ';
				display: [ :input | input ];
				enableFilterWithAction: [ :dataSource :pattern :selectedRow | selectedRow browse ] named: 'Browse' ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'usmanbhatti 10/13/2015 11:08'!
fastListOutlineSimple
	"self new fastListOutlineSimple openOn: Object"

	<glmBrowser: 'Fast List Outline Simple' input: 'Object'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | 
			a fastList
				title: 'Example with an Outline List';
				display: [ :x | x allSubclasses collect: [ :each | each allSubclasses ] ];
				withSeparators ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/9/2015 16:14'!
fastListOutlineWithTag
	"self new fastListOutlineWithTag openOn: Object"

	<glmBrowser: 'Fast List Outline with Tag' input: 'Object'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow:
				[ :a | 
			a fastList
				title: 'Example with an Outline List';
				display: [ :x | x allSubclasses collect: [ :each | each allSubclasses ] ];
				withSeparators;
				tags: [ :item | item asString first asString ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 10/6/2015 15:37'!
fastListSimple
	"self new fastListSimple openOn: (Smalltalk allClassesAndTraits)"

	<glmBrowser: 'Fast List Simple' input: 'Smalltalk allClassesAndTraits'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastList display: Smalltalk allClassesAndTraits ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:04'!
fastTableSimple
	<glmBrowser: 'Fast Table simple' input: '100'>
	"| f | 
	f := self new simpleTable.
	f openOn: 1000.
	(f panes first port: #selection) value: 1"
	| wrapper |	
	wrapper := GLMWrapper new.
	wrapper show: [:a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ] ].
	^ wrapper! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:04'!
fastTableWithIcons
	<glmBrowser: 'Fast Table with icons' input: '($A to: $z)'>
	"self new tableWithIcons openOn: ($A to: $z)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a act: [:presentation | presentation inspect] entitled: 'Inspect'. 
		a fastTable
			title: 'Table with actions';
			act: [:presentation | presentation inspect] entitled: 'Inspect'; 
			column: 'Character' evaluated: [ :each | each asString ];
			column: 'ASCII' evaluated: [ :each | each asInteger printString ];
			selectionAct: [:tree | tree selection inspect ] on: $i entitled: 'Inspect';
			icon: [:each | 
				each asInteger odd 
					ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ] 
					ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ]].
	
	browser transmit 
		to: #two; 
		from: #one; 
		andShow: [:a | a text ].
	
	browser transmit
		from: #one port: #strongSelection;
		to: #two;
		andShow: [ :a | a text format: [ :item | 'STRONG: ', item asString ] ].
	
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/4/2015 16:13'!
fastTableWithSearch
	<glmBrowser: 'Fast Table with search' input: '100'>
	"| f | 
	f := self new fastTableWithSearch.
	f openOn: 1000.
	(f panes first port: #selection) value: 1"
	| wrapper |	
	wrapper := GLMWrapper new.
	wrapper show: [:a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ];
			enableSearch;
			allowDeselection ].
	^ wrapper! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 14:08'!
fastTreeSimple
	"self new fastTreeSimple openOn: (GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])"

	<glmBrowser: 'Fast Tree Simple' input: '(GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | 
			a fastTree
				title: 'Fast Tree';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ].
			a fastTree
				title: 'Fast Expanded';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				allExpanded.
			a fastTree
				title: 'Fast Tree Root Expanded';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				rootsExpanded.
			a fastTree
				title: 'Fast Tree Expanded Until 1';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				expandedUntil: 1.
				 ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 14:16'!
fastTreeStrategies
	"self new fastTreeStrategies openOn: (GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])"

	<glmBrowser: 'Fast Tree Function Strategies' input: '(GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | 
			a fastTree
				title: 'Fast Tree Filter Visibles';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter; "Could be search also"
				strategy: #default. "Optional in this case."
			a fastTree
				title: 'Fast Tree Filter Roots';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter;
				strategy: #rootsOnly.
			a fastTree
				title: 'Fast Tree Filter All';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter;
				strategy: #allItems.
			a fastTree
				title: 'Fast Tree Search All';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableSearch;
				strategy: #allItems.
				 ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/16/2015 10:04'!
fastTreeWithIcon
	"self new fastTreeWithIcon openOn: (1 to: 10)"

	<glmBrowser: 'Fast Tree With Icon' input: '(1 to: 10)'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow:
				[ :a | 
			a fastTree
				title: 'Fast Tree';
				children: [ :x | 1 to: x - 1 ];
				icon: [ :each | 
					each asInteger odd
						ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ]
						ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 13:52'!
tagBlockWith: num
	| tagBlock |
	tagBlock := [ :item | 
	item isNumber
		ifTrue:
			[ {(item even
				ifTrue: [ 'even' ]
				ifFalse: [ 'odd' ]).
			(item < num
				ifTrue: [ '<' , num asString ]
				ifFalse: [ '>=' , num asString ])} ] ].
	^ tagBlock! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicFTRenderer
	instanceVariableNames: 'tableModel tableMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFTRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:33' prior: 0!
I am an abstract class that define the way to render a FastTable related presentation.

Description
--------------------

I manage a FastTable dataSource and a FastTable morph. I define how to build and render them. I try to manage the maximum of the rendering and I let my subclasses define some specialities. 

My subclasses are use by a FastTable related presentation as GLMFastListPresentation or GLMFastTreePresentation. 
I use a FTTableMorph to manage the rendering and a subclass of FTDataSource to manage the data. 

Public API and Key Messages
--------------------

- #render: aPresentation 		This method is the main method of the class It allow to render myself on the presentation.
		
My subclasses should manage: 

- #createDataSourceFrom: aPresentation 		This method have to return  a new dataSource that match the presentation.
		
- #specificTableMorphInitializiation and #specificDataSourceInitializiation 		are two methods  my subclasses can override to add functionalites to the FastTable.

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	tableModel:		Is a DataSource for Glamour that will hold the data of the presentation.
	tableMorph:		Is a FastTableMorph use to display the presentation.
!

!GLMMorphicFTRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 11/4/2015 14:16'!
actOnContextChanged: anAnnouncement 
	anAnnouncement property = #selection ifTrue: [ 
		tableModel announcer 
			suspendAll: self suspendedAnnouncements
			while: [ 
				tableModel explicitSelection: anAnnouncement value ] ]! !

!GLMMorphicFTRenderer methodsFor: 'rendering' stamp: 'usmanbhatti 11/16/2015 14:42'!
actOnUpdatedPresentation: anAnnouncement
	tableModel resetElements.
	tableMorph refresh! !

!GLMMorphicFTRenderer methodsFor: 'adding' stamp: 'CyrilFerlicot 11/4/2015 15:01'!
addFastTableIn: container
	container addMorphBack: tableMorph! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:47'!
createDataSourceFrom: aPresentation
	self subclassResponsibility! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 15:04'!
createFastTable
	^ FTTableMorph new! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2016 07:46'!
dataSourceUpdated: announcement
	tableModel ifNotNil: [ self unsubscribeDataSource: tableModel ].
	tableModel := announcement newDataSource.
	self initializeAnnouncementForDataSource! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 11/17/2015 12:15'!
initializeAnnoucementForPresentation: aPresentation
	aPresentation when: GLMDataSourceUpdated send: #dataSourceUpdated: to: self.
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'usmanbhatti 11/16/2015 15:08'!
initializeAnnouncementForDataSource
	tableModel announcer
		when: GLMTreeMorphSelectionChanged
		do: [ :ann | 
			tableModel glamourPresentation announcer
				suspendAllWhile: [ 
					tableModel glamourPresentation selection: ann selectionValue.
					tableModel glamourPresentation selectionPath: ann selectionPathValue ] ].
	tableModel announcer
		when: GLMTreeMorphStrongSelectionChanged
		do: [ :ann | tableModel glamourPresentation strongSelection: ann strongSelectionValue ].
	tableMorph
		onAnnouncement: FTStrongSelectionChanged send: #strongSelection: to: tableModel;
		onAnnouncement: FTSelectionChanged send: #selection: to: tableModel! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:52'!
initializeTableModel: aPresentation
	tableModel := (self createDataSourceFrom: aPresentation)
		glamourPresentation: aPresentation;
		yourself.
	self specificDataSourceInitializiation! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'AndreiChis 1/9/2016 21:15'!
initializeTableMorph
	| presentation |
	presentation := tableModel glamourPresentation.
	tableMorph := self createFastTable.
	tableMorph
		dataSource: tableModel;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cornerStyle: tableMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 0);
		dragEnabled: presentation allowsItemDrag;
		dropEnabled: presentation isDropTarget;
		allowsDeselection: presentation allowsDeselection.
	self setFastTableLayoutFrame: tableMorph.
	presentation isMultiple
		ifTrue: [ tableMorph beMultipleSelection ]
		ifFalse: [ tableMorph beSingleSelection ].
	self specificTableMorphInitializiation! !

!GLMMorphicFTRenderer methodsFor: 'rendering' stamp: 'AndreiChis 12/13/2016 19:37'!
render: aPresentation
	| container |
	container := GLMMorphic containerMorph.
	self initializeAnnoucementForPresentation: aPresentation.
	self initializeTableModel: aPresentation.
	self initializeTableMorph.
	self addFastTableIn: container.
	self installActionsOnModel: tableModel fromPresentation: aPresentation.
	self installKeystrokeActionsOnMorph: tableMorph fromPresentation: aPresentation.
	aPresentation selection ifNotNil: [ tableModel announcer suspendAll: self suspendedAnnouncements while: [ tableModel explicitSelection: aPresentation selection ] ].
	"No need to initialize the announcements here as setting the data source in a FTTableMorph will do it."
	"self initializeAnnouncementForDataSource."
	^ container! !

!GLMMorphicFTRenderer methodsFor: 'build ui' stamp: 'CyrilFerlicot 11/4/2015 14:37'!
setFastTableLayoutFrame: newTableMorph
	newTableMorph layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1))! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:11'!
specificDataSourceInitializiation
	"Override me if you need to add something to the data source."! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:12'!
specificTableMorphInitializiation
	"Override me if need to add something to the tableMorph."

	| presentation |
	presentation := tableModel glamourPresentation.
	"I set the right function."
	presentation isSearchable
		ifTrue: [ tableMorph enableSearch ].
	presentation isFilterable
		ifTrue: [ presentation needActionButton
				ifTrue: [ tableMorph enableFilterWithAction: presentation actionBlock named: presentation actionName ]
				ifFalse: [ tableMorph enableFilter ] ].
	(presentation isFilterable or: [ presentation isSearchable ])
		ifFalse: [ tableMorph disableFunction ]
		ifTrue: [ tableMorph explicitFunction ]! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 11/4/2015 15:02'!
suspendedAnnouncements
	^ OrderedCollection  
		with: GLMTreeMorphSelectionChanged 
		with: GLMTreeMorphStrongSelectionChanged 
		with: GLMMenuItemSelected 
		with: GLMKeyStroke! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 11/17/2015 12:18'!
unsubscribeDataSource: aTableModel
	aTableModel announcer unsubscribe: self.
	tableMorph announcer unsubscribe: aTableModel! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastListRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:39' prior: 0!
I am a Morphic renderer for a GLMFastListPresentation.

Description
--------------------

I use a GLMFastListDataSource to manage the data of the table.
!

!GLMMorphicFastListRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/10/2015 11:49'!
createDataSourceFrom: aPresentation
	^ aPresentation allowSeparators
		ifTrue: [ GLMFastListOutlineDataSource new ]
		ifFalse: [ GLMFastListDataSource new ]! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastTableRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:39' prior: 0!
I am a Morphic renderer for a GLMFastTablePresentation.

Description
--------------------

I use a GLMFastTableDataSource to manage the data of the table.
!

!GLMMorphicFastTableRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/10/2015 11:49'!
createDataSourceFrom: aPresentation
	^ GLMFastTableDataSource new! !

!GLMMorphicFastTableRenderer methodsFor: 'initialization' stamp: 'TudorGirba 1/21/2016 23:06'!
specificTableMorphInitializiation
	| presentation |
	super specificTableMorphInitializiation.
	presentation := tableModel glamourPresentation.
	tableMorph intercellSpacing: tableModel glamourPresentation intercellSpacing.
	tableMorph beResizable.
	tableMorph
		columns:
			(presentation columns
				collect:
					[ :each | 
					GLMFastTableColumn new
						id: (presentation titleValueOfColumn: each);
						width: each width;
						glamourColumn: each;
						target: tableModel actionSelector: #sortByColumn: arguments: {each};
						yourself ]).
	presentation shouldShowHeader 
		ifFalse: [ tableMorph hideColumnHeaders ]
		ifTrue: [ tableMorph showColumnHeaders ]! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastTreeRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:40' prior: 0!
I am a Morphic renderer for a GLMFastTreePresentation.

Description
--------------------

I use a GLMFastTreeDataSource to manage the data of the tree.
!

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:48'!
createDataSourceFrom: aPresentation
	^ GLMFastTreeDataSource new! !

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:10'!
specificDataSourceInitializiation
	| presentation |
	super specificDataSourceInitializiation.
	presentation := tableModel glamourPresentation.
	tableModel
		childrenBlock: presentation children;
		maxDepth: presentation maxDepth;
		searchStrategy: presentation strategy! !

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:12'!
specificTableMorphInitializiation
	| presentation |
	super specificTableMorphInitializiation.
	presentation := tableModel glamourPresentation.
	"If needed I extant the tree"
	presentation shouldAllExpand
		ifTrue: [ tableModel expandAll ].
	presentation shouldRootsExpand
		ifTrue: [ tableModel expandRoots ].
	presentation shouldExpandToLevel
		ifTrue: [ tableModel expandAllTo: presentation expandLevel ]! !
